#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <sys\timeb.h>
#include "winsock.h"

#include "settings.h"

#define LOST		20
#define DUPL		20		// LOST + DUPL < 100 !!!
#define TIMEOUT	100

int mod(int x, int M);

typedef struct {
	int num;
   int length;
   int ack;
	char data[BUFFSIZE];
} packet;

class Window {
	private:
		packet p[WINDOW];
   	int sending;
      int readed;
	   int acknowledged;
      int last_time;
      bool lastone;

      FILE *in;
		WSADATA wsaData;
		SOCKET SendSocket;
		sockaddr_in RecvAddr;

      void settimeout();

   public:
   	Window(char *host, char *file);
      void napln();
      void posli();
      void ack();
      void isTimeout();
      bool isDone();
};

Window::Window(char *host, char *file) {
   sending = 0;
   acknowledged = -1;
   readed = -1;
   lastone = true;

   if((in = fopen(file, "rb")) == NULL) {
      printf("Cannot open input file %s.\n", file);
      getch();
      exit(1);
   }

	//---------------------------------------------
	// Initialize Winsock
	int iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	if(iResult != NO_ERROR) {
		printf("Error at WSAStartup()\n");
		getch();
		exit(1);
	}

	//---------------------------------------------
	// Create a socket for sending data
	SendSocket = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);

	if(SendSocket == INVALID_SOCKET) {
		printf("Error at socket(): %ld\n", WSAGetLastError());
		WSACleanup();
		getch();
      exit(1);
	}

	//---------------------------------------------
	// Set up the RecvAddr structure with the IP address of
	// the receiver (in this example case "123.456.789.1")
	// and the specified port number.
	RecvAddr.sin_family = AF_INET;
	RecvAddr.sin_port = htons(ECHOPORT);
	RecvAddr.sin_addr.s_addr = inet_addr(host);

   randomize();

   p[0].ack = 1;
   p[0].num = -1; 
   for(int i = 1; i < WINDOW; i++) {
   	p[i].ack = 2;
      p[i].num = -1;
   }
}

void Window::napln() {
	int start = -1;

	for(int i = 0; i < WINDOW; i++) {
   	if(p[i].ack == 1)
      	start = i+1;
   }

   if(start > -1) {
		for(int i = 0; i < WINDOW; i++) {
   		if((i + start) < WINDOW)
		   	p[i] = p[i+start];
   	   else {
      		p[i].ack = 2;
            p[i].num = BUFFLENGTH + 1;
            p[i].length = 0;
         }
	   }
		for(int i = 0; i < WINDOW; i++) {
   		if(!feof(in)) {
         	if(p[i].ack > 0) {
            	p[i].length = fread(p[i].data, 1, BUFFSIZE, in);
   	      	p[i].ack = 0;
            	p[i].num = (++readed) % BUFFLENGTH;
            }
      	}
         else if(lastone && (p[i].ack > 0)) {
            	p[i].length = 0;
   	      	p[i].ack = 0;
            	p[i].num = (++readed) % BUFFLENGTH;
               printf("Finishing packet is %d\n", p[i].num);
               lastone = false;
         }
	   }
   }
}

void Window::posli() {
	int err;
   int i = mod(sending - acknowledged - 1, WINDOW);
	if((i < WINDOW) && (p[i].ack == 0) && (mod(sending - acknowledged - 1, BUFFLENGTH) < WINDOW)) {
   	if((p[i].length == 0) && (i != 0))
      	return;
		char buf[BUFFSIZE + 3] = "";
		buf[0] = p[i].length;
		buf[1] = sending;
      if(p[i].num != sending) {
      	printf("Spatne cislo %d!!! ocekavano %d", p[i].num, sending);
         exit(1);
      }
		memcpy(buf + 2, p[i].data, p[i].length);

		int rnd = rand() % 100;
		if(rnd < LOST) {
		 	printf("Losing packet %d\n", sending);
		}
		else if(rnd < (DUPL + LOST)) {
   		printf("Duplicating packet %d\n", sending);
			if((err = sendto(SendSocket, buf, p[i].length + 2, 0, (SOCKADDR *) &RecvAddr, sizeof(RecvAddr))) == SOCKET_ERROR){
				printf( "sendto() failed. %d\n", WSAGetLastError() );
				WSACleanup();
				getch();
	   	   exit(1);
			}
			if((err = sendto(SendSocket, buf, p[i].length + 2, 0, (SOCKADDR *) &RecvAddr, sizeof(RecvAddr))) == SOCKET_ERROR){
				printf( "sendto() failed. %d\n", WSAGetLastError() );
				WSACleanup();
				getch();
   		   exit(1);
			}
  			printf("2x%d bytes send\n", err);
		}
		else {
	   	printf("Sending packet %d\n", sending);
			if((err = sendto(SendSocket, buf, p[i].length + 2, 0, (SOCKADDR *) &RecvAddr, sizeof(RecvAddr))) == SOCKET_ERROR){
				printf( "sendto() failed. %d\n", WSAGetLastError() );
				WSACleanup();
				getch();
		  	   exit(1);
	   	}
  			printf("%d bytes send\n", err);
		}
	  	sending = (sending + 1) % BUFFLENGTH;

	   struct timeb t;
	   ftime(&t);
		last_time = (t.time % 1000)*1000 + t.millitm;
   }
}

void Window::ack() {
	char RecvBuf[BUFFSIZE+1] = "";
   int err;
   timeval t;
   fd_set rset;
   FD_ZERO(&rset);
   FD_SET(SendSocket, &rset);
   t.tv_sec = t.tv_usec = 0;

   if((err = select(0, &rset, NULL, NULL, &t)) == SOCKET_ERROR) {
   	printf("error in select(): %d\n", WSAGetLastError());
      getch();
      exit(1);
   }
   else if(err != 0) {
		if((err = recvfrom(SendSocket, RecvBuf, BUFFSIZE, 0, NULL, NULL)) == SOCKET_ERROR) {
			if(p[0].ack == 0) {
         	printf("Finishing packet not acknowledged\n");
         	p[0].ack = 2;
            return;
         }
   	   printf("Error recieving: %d\n", WSAGetLastError());
			getch();
  		   exit(1);
      }
      if(err == 0) {
         printf("Nothing recieved\n");
         return;
      }
      int new_a = byte(RecvBuf[0]);
      if(mod(new_a - acknowledged - 1, BUFFLENGTH) <= WINDOW) {
	      printf("Recieved acknowledge %d\n", new_a);
         for(int i = 0; i < WINDOW; i++) {
         	if((mod(new_a - p[i].num, BUFFLENGTH) <= WINDOW) && (p[i].ack == 0)) {
            	p[i].ack = 1;
               printf("Acknowledged packet %d on pos %d\n", p[i].num, i);
            }
         }
         acknowledged = new_a;
      }
   }
}

void Window::isTimeout() {
   struct timeb t;
   ftime(&t);
	int new_time = (t.time % 1000)*1000 + t.millitm;
   if((new_time - last_time) > TIMEOUT) {
   	sending = (acknowledged + 1) % BUFFLENGTH;
      printf("Timeouted\n");
      last_time = new_time;
   }
}

bool Window::isDone() {
   for(int i = 0; i < WINDOW; i++) {
     	if(p[i].ack != 2)
     		return false;
   }
   return true;
}

int mod(int x, int M) {
	int y = x % M;
   if(y < 0)
   	return y + M;
  	return y;
}

int main(int argc, char * argv[]) {
   if(argc < 3) {
      printf("Insufficient arguments. Usage:\n %s host file", argv[0]);
      getch();
      return 1;
   }

   Window *run = new Window(argv[1], argv[2]);

	while(!(run->isDone())) {
   	run->napln();
      run->posli();
      run->ack();
      run->isTimeout();
   }

   printf("\n\nFinished sending. Closing socket and file.\n");
   delete run;
   printf("Done...\n");
   getch();
   return 0;
}
